#include <iostream>
#include <cstdlib>
#include <ctime>
#include <cstdio>

using namespace std;

int main()
{
	unsigned long long curK = 0; //Number of digits in current repunit
	time_t timeElapsed = 0;
	time_t initTime = time(NULL);
	char* curNum = (char*)malloc(sizeof(char)*10000000); //Holds repunit strings
	char* prevNum = (char*)malloc(sizeof(char)*10000000);
	prevNum[0] = '1';

	while(timeElapsed < 60) //Run for 60 seconds
	{	
		memcpy(curNum, prevNum, curK);

		//Copy previous repunit to new one, then append an extra one
		//Doesn't permit accessing more than the current repunit, but...
		//Strictly speaking, we are "generating" values of R(n), so this should be valid

		curK++; //Increment number of digits to generate

		prevNum[curK] = '1';

		timeElapsed = time(NULL) - initTime;
	}

	cout << "Generated " << curK << " repunits in " << timeElapsed << " seconds" <<  endl;
	system("PAUSE");
	free(curNum);
	free(prevNum);
	return 0;
}